"use strict";
//SecretAgent
// 
//Licence Terms
// 
//1) SecretAgent is copyright Peter John
//
//You may;
//
//2) Download and install SecretAgent software for personal or commercial use
//
//3) You may use SecretAgent software on as many computers as you wish, without charge
//
//4) You may decompile the software, but only to verify the code will perform to specification
//
//You may not;
//
//5) Rebrand or bundle the code, or any part of the code, with any other software product
//
//6) Incorporate the code into a product or service involving Phorm or any other advertising system
//
//Specific Restrictions;
//
//7) SecretAgent software is not licenced for use by employees or sub-contractors working for Phorm, BT, Plusnet, TalkTalk, Virgin, Vodafone, BBC, News Corporation, News International, Logica, Experian, Verizon, Facebook, Schillings, Berenberg, Blackrock, Dartley Bank
//
//8) SecretAgent software is not licenced for use by employees or sub-contractors working for UK Central Government (including but not limited to the Information Commissioners Office, Home Office, Ministry of Justice, Dept for Business Innovation and Skills, Cabinet Office, Ministry of Defence, Foreign Office, Department for Education).
//
//9) SecretAgent software is not licenced for use by employees or sub-contractors working for UK Police forces
// 

window.addEventListener("load",   function() { SecretAgent.init();   }, false);
window.addEventListener("unload", function() { SecretAgent.uninit(); }, false);


// ------------------------------------------------------------------------------------------------
// Mozilla ISODateString (backward compatible)
function ISODateString(d){
  function pad(n){return n<10 ? '0'+n : n}
  return d.getUTCFullYear()+'-'
      + pad(d.getUTCMonth()+1)+'-'
      + pad(d.getUTCDate())+'T'
      + pad(d.getUTCHours())+':'
      + pad(d.getUTCMinutes())+':'
      + pad(d.getUTCSeconds())+'Z'
}

// ------------------------------------------------------------------------------------------------
// Show the SecretAgent preferences dialog
function openSecretAgentPrefs(){		
  window.openDialog("chrome://SecretAgent/content/preferences.xul","SecretAgent Prefs","centerscreen, chrome, toolbar, resizable, modal");
  // Initialise Agents
  SecretAgent.initialiseUserAgentList();

  // Initialise Accept headers
  SecretAgent.initialiseAcceptList();
  
  // Initialise OSCPU strings
  SecretAgent.initialiseOSCPUList();
  
  // Initialise Whitelist
  SecretAgent.initialiseWhitelist();

  var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                 getService(Components.interfaces.nsIPrefService);
  secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

  // Toggle Status and Set the status bar message
  if (secretAgentPreferences.getBoolPref("StealthMode"))
  {
      SecretAgent.on();
  }
  else
  {
      SecretAgent.off();
  }  
  
}

// ------------------------------------------------------------------------------------------------
// SecretAgent Addon Listener - used to detect uninstall operations, and restore defaults
var SecretAgentAddonListener = {
     onUninstalling: function( addon, needsRestart ) {
	   if (addon.id == "SecretAgent@Dephormation.org.uk") {
dump("SecretAgent: removing all overrides ready for uninstall.\n");
          // Remove all overrides
          SecretAgent.off();
	   }   
	 },
	 
     onDisabling: function( addon, needsRestart ) {
	   if (addon.id == "SecretAgent@Dephormation.org.uk") {
dump("SecretAgent: removing all overrides ready for disable.\n");
          // Remove all overrides
          SecretAgent.off();
	   }   
	 },

     onEnabled: function( addon ) {
	   if (addon.id == "SecretAgent@Dephormation.org.uk") {
dump("SecretAgent: switching SecretAgent on ready for enable.\n");
          // Enable overrides
          SecretAgent.on();
	   }   
	 }
};

try {
  Components.utils.import("resource://gre/modules/AddonManager.jsm");
  AddonManager.addAddonListener(SecretAgentAddonListener);
} catch (e) { dump("SecretAgent: Failed to install addon listener: "+e.message); }

// ------------------------------------------------------------------------------------------------
// SecretAgent Status Bar OnClick Event Handler - used to handle status bar operations
function SecretAgentStatusBarOnClickEventHandler(e)
{
    var buttonCode = e.button;

    switch (buttonCode){
      case 0  : // Left button clicked
                SecretAgent.toggle();
                break;
      case 1  : // Middle button clicked
                break;
      case 2  : // Right button clicked
                break;
      default : //alert('Unexpected code: ' + btnCode);
    }
}

// ------------------------------------------------------------------------------------------------
// SecretAgent Context Menu Event Handler - used to handle context menu operations
function SecretAgentContextMenuOnPopupEventHandler(e)
{
dump("SecretAgent: Context popup event handler;\n");
      var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");
	
     if (secretAgentPreferences.getBoolPref("StealthMode"))
	 {
       document.getElementById("SecretAgent_context_menu_toggle").label= "Disable Stealth Mode";
	 }
	 else
	 {
       document.getElementById("SecretAgent_context_menu_toggle").label= "Enable Stealth Mode";
	 }

	 if (SecretAgent.Whitelist.indexOf(window.content.location.hostname) > -1)
	 {
		document.getElementById("SecretAgent_context_menu_addtowhitelist").label= "Remove " + window.content.location.hostname + " from whitelist";
     }
	 else
	 {
		document.getElementById("SecretAgent_context_menu_addtowhitelist").label= "Add " + window.content.location.hostname + " to whitelist";
	 }
}

// ------------------------------------------------------------------------------------------------
// SecretAgent Status Bar Menu Event Handler - used to handle status bar menu operations
function SecretAgentStatusBarOnPopupEventHandler(e)
{
dump("SecretAgent: Status popup event handler;\n");
      var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");
	
     if (secretAgentPreferences.getBoolPref("StealthMode"))
	 {
       document.getElementById("SecretAgent_statusbar_menu_toggle").label= "Disable Stealth Mode";
	 }
	 else
	 {
       document.getElementById("SecretAgent_statusbar_menu_toggle").label= "Enable Stealth Mode";
	 }

	 if (SecretAgent.Whitelist.indexOf(window.content.location.hostname) > -1)
	 {
       document.getElementById("SecretAgent_statusbar_menu_addtowhitelist").label= "Remove " + window.content.location.hostname + " from whitelist";
     }
	 else
	 {
       document.getElementById("SecretAgent_statusbar_menu_addtowhitelist").label= "Add " + window.content.location.hostname + " to whitelist";
	 }
}

// ------------------------------------------------------------------------------------------------
// SecretAgent HTTP header visitor - used to debug header handling
var SecretAgentHttpHeaderVisitor = {
     visitHeader: function( header, value ) {
dump("SecretAgent: Header; " + header + ":" + value + "\n");
     }
};

// ------------------------------------------------------------------------------------------------
// SecretAgent HTTP Observer - Called as an http request is made. 

var SecretAgentHTTPObserver = {

// ------------------------------------------------------------------------------------------------
// Generate a random ETag
  RandomETag: function (length) {
	var chars = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXTZabcdefghiklmnopqrstuvwxyz_";
	var randomETag = '';
	for (var i=0; i<length; i++) {
		var rnum = Math.floor(Math.random() * chars.length);
		randomETag += chars.substring(rnum,rnum+1);
	}
	return randomETag;
  },
  
  observe: function(subject, topic, data) {
    var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");
    var generalUserAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentPreferences = generalUserAgentPreferences.getBranch("general.useragent.");
    var generalOSCPUPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalOSCPUPreferences = generalOSCPUPreferences.getBranch("general.oscpu.");

    if (topic == "http-on-modify-request")
	{
dump("SecretAgent: Request: http-on-modify-request;\n");
       var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
	   var domain = httpChannel.URI.host;
dump("SecretAgent: Request: Processing ["+httpChannel.URI.spec+"];\n");
	   
	   // Dump http headers for debug
       // httpChannel.visitRequestHeaders( SecretAgentHttpHeaderVisitor );
       // ---------------------------
	   
       if (secretAgentPreferences.getBoolPref("StealthMode"))
       {
          if (SecretAgent.Whitelist.indexOf(domain) > -1)
          {
             SecretAgent.setStatusBarPanelWhitelist();

             if (secretAgentPreferences.getBoolPref("RotateUserAgent"))
             {
dump("SecretAgent: Request: Whitelisting UA;\n");
                SecretAgent.clearGlobalUserAgentOverrides();
                SecretAgent.clearDomainSpecificUserAgentOverrides( domain );
             }
             if (secretAgentPreferences.getBoolPref("RotateOSCPU"))
             {
dump("SecretAgent: Request: Whitelisting OSCPU;\n");
                SecretAgent.clearGlobalOSCPUOverrides();
             }
			 
             httpChannel.setRequestHeader("User-Agent", window.navigator.userAgent, false);
          }
          else
          {
             SecretAgent.setStatusBarPanel();
dump("SecretAgent: Request: Stealth actions;\n");
             if (secretAgentPreferences.getBoolPref("SpoofETags"))
             {
dump("SecretAgent: Request: Spoof eTags;\n");
                try
				{
dump("SecretAgent: Request: Finding eTags;\n");
				   var ETag=httpChannel.getRequestHeader("If-None-Match");
dump("SecretAgent: Request: ETag found;" + ETag + "\n");
				}
				catch(e)
				{
dump("SecretAgent: Request: Exception;" + e.message + "\n");
				}
				var ETagLength = Math.floor((Math.random()*10)+5); 
				var ETag = '';
				ETag = this.RandomETag(ETagLength);
dump("SecretAgent: Request: Spoofing ETag;" + ETag + "\n");
                httpChannel.setRequestHeader("If-None-Match", ETag, false);
             }
             if (secretAgentPreferences.getBoolPref("RotateUserAgent"))
             {
dump("SecretAgent: Request: Rotating UA;\n");
                var SecretAgent_statusbarpanel = document.getElementById("SecretAgent_statusbarpanel");
                var randomUserAgent =Math.floor(Math.random()*SecretAgent.UserAgentList.length);
                generalUserAgentPreferences.setCharPref("override", SecretAgent.UserAgentList[randomUserAgent] );
                generalUserAgentPreferences.setCharPref("override." + domain, SecretAgent.UserAgentList[randomUserAgent] );
                SecretAgent_statusbarpanel.setAttribute("tooltiptext", "Last User Agent: " + SecretAgent.UserAgentList[randomUserAgent] );
                httpChannel.setRequestHeader("User-Agent", SecretAgent.UserAgentList[randomUserAgent], false);
             }
             if (secretAgentPreferences.getBoolPref("RotateAccept"))
             {
dump("SecretAgent: Request: Rotating Accept;\n");
                var randomAccept =Math.floor(Math.random()*SecretAgent.AcceptList.length);
                httpChannel.setRequestHeader("Accept", SecretAgent.AcceptList[randomAccept], false);
             }
             if (secretAgentPreferences.getBoolPref("RotateOSCPU"))
             {
dump("SecretAgent: Request: Rotating OSCPU;\n");
                var randomOSCPU =Math.floor(Math.random()*SecretAgent.OSCPUList.length);
                generalOSCPUPreferences.setCharPref("override", SecretAgent.OSCPUList[randomOSCPU] );
             }
             if (secretAgentPreferences.getBoolPref("SpoofVia"))
             {
dump("SecretAgent: Request: Spoofing VIA header;\n");
                var a =(1+Math.floor(Math.random()*254));
                var b =(1+Math.floor(Math.random()*254));
                var c =(1+Math.floor(Math.random()*254));
                var d =(1+Math.floor(Math.random()*254));
                httpChannel.setRequestHeader("Via", "1.1 "+a+"."+b+"."+c+"."+d, false);
             }
             if (secretAgentPreferences.getBoolPref("SpoofForwardedFor"))
             {
dump("SecretAgent: Request: Spoofing X-Forwarded-For header;\n");
                var a =(1+Math.floor(Math.random()*254));
                var b =(1+Math.floor(Math.random()*254));
                var c =(1+Math.floor(Math.random()*254));
                var d =(1+Math.floor(Math.random()*254));
                httpChannel.setRequestHeader("X-Forwarded-For", a+"."+b+"."+c+"."+d, false);
             }
          }
       }
    }
    if (topic == "http-on-examine-response" || topic == "http-on-examine-cached-response" || topic == "http-on-examine-merged-response" )
	{
dump("SecretAgent: Response: "+topic+"\n");
       var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
	   var domain = httpChannel.URI.host;
	   
dump("SecretAgent: Response: Processing ["+httpChannel.URI.spec+"];\n");

	   // Dump http headers for debug
       // httpChannel.visitResponseHeaders( SecretAgentHttpHeaderVisitor );
       // ---------------------------
	   
       if (secretAgentPreferences.getBoolPref("StealthMode"))
       {
          if (SecretAgent.Whitelist.indexOf(domain) > -1)
          {
             SecretAgent.setStatusBarPanelWhitelist();
          }
          else
          {
dump("SecretAgent: Response: Stealth actions;\n");
             if (secretAgentPreferences.getBoolPref("SpoofDatestamps"))
             {
dump("SecretAgent: Response: Spoof Datestamps;\n");
                try
				{
dump("SecretAgent: Response: Finding Datestamps;\n");
				   var DateStamp = new Date( httpChannel.getResponseHeader("Last-Modified") );
dump("SecretAgent: Response: DateStamps found;" + DateStamp.toUTCString() + "\n");
                   DateStamp = new Date( DateStamp.getTime() - Math.floor(Math.random()*24*60*60*1000) );
dump("SecretAgent: Response: Spoofing DateStamp;" + DateStamp.toUTCString() + "\n");
                   httpChannel.setResponseHeader("Last-Modified", DateStamp.toUTCString(), false);
                   httpChannel.setResponseHeader("Test", DateStamp.toUTCString(), false);
				}
				catch(e)
				{
dump("SecretAgent: Response: Exception;" + e.message + "\n");
				}
			 }
          }
		}
	}
  },

// ------------------------------------------------------------------------------------------------
  enable: function() {
     // Add HTTP Observer
     var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

     try {
        observerService.addObserver(SecretAgentHTTPObserver, "http-on-modify-request", false);
        observerService.addObserver(SecretAgentHTTPObserver, "http-on-examine-response", false);
		observerService.addObserver(SecretAgentHTTPObserver, "http-on-examine-cached-response", false);
		observerService.addObserver(SecretAgentHTTPObserver, "http-on-examine-merged-response", false);
     }
     catch(err) {
        dump(err.message);
     }
   },

// ------------------------------------------------------------------------------------------------
  disable: function() {
     // Remove HTTP Observer
     var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);

     try {
        observerService.removeObserver(SecretAgentHTTPObserver, "http-on-modify-request");
        observerService.removeObserver(SecretAgentHTTPObserver, "http-on-examine-response");
     }
     catch(err) {
        dump(err.message);
     }
  },

  QueryInterface : function(aIID) {
    if (aIID.equals(Components.interfaces.nsISupports) ||
        aIID.equals(Components.interfaces.nsIObserver))
      return this;
    throw Components.results.NS_NOINTERFACE;
  }
}


// ------------------------------------------------------------------------------------------------
// SecretAgent Add On - the work horse of the browser add on. 


var SecretAgent = {

  //----------------------------------------------------------------------------------------------------
  init: function() {
    dump("SecretAgent: initialising\n");
    // Get the "extensions.SecretAgent." branch
    var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
    preferences = preferences.getBranch("extensions.SecretAgent.");

    this.strings = document.getElementById("SecretAgent-strings");

    if (preferences.getBoolPref("showStartupAlert"))
    {
            dump("SecretAgent: SecretAgent displaying splash screen");
		window.openDialog("chrome://SecretAgent/content/splash.xul","SecretAgent Installed","centerscreen, chrome, toolbar, modal");
    }

    // Initialise Agents
    SecretAgent.initialiseUserAgentList();

    // Initialise Accept Headers
    SecretAgent.initialiseAcceptList();

    // Initialise OSCPU strings
    SecretAgent.initialiseOSCPUList();

    // Initialise Whitelist
    SecretAgent.initialiseWhitelist();

    // Add http observer
    dump("SecretAgent: initialising HTTP observer\n");
    SecretAgentHTTPObserver.enable();

    SecretAgent.setStatusBarPanel();

    dump("SecretAgent: adding pageload listeners\n");
    var appcontent = document.getElementById("appcontent");   // browser
    if(appcontent)
	{
      appcontent.addEventListener("DOMContentLoaded", this.onPageLoad, true);
	}

dump("SecretAgent: HTTP User Agent rotation loaded!\n");

  },

  //----------------------------------------------------------------------------------------------------
  uninit: function() {
dump("SecretAgent: uninitialising\n");

dump("SecretAgent: removing http observer\n");

    // Remove http listener
    SecretAgentHTTPObserver.disable();

    // Tidy up overrides
     var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

     if (secretAgentPreferences.getBoolPref("RotateUserAgent"))
     {
         SecretAgent.clearGlobalUserAgentOverrides();
         SecretAgent.clearAllDomainSpecificUserAgentOverrides();
     }
     if (secretAgentPreferences.getBoolPref("RotateOSCPU"))
     {
         SecretAgent.clearGlobalOSCPUOverrides();
     }	
  },

  // ------------------------------------------------------------------------------------------------
  // Set the text in the status bar panel
  setStatusBarPanel: function(){		
     var preferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     preferences = preferences.getBranch("extensions.SecretAgent.");

     // Set the status bar message
     var SecretAgent_statusbarpanel = document.getElementById("SecretAgent_statusbarpanel");
     SecretAgent_statusbarpanel.image = "chrome://SecretAgent/skin/icon16.png";

     if (preferences.getBoolPref("StealthMode"))
     {
           SecretAgent_statusbarpanel.label = "Stealth";
           SecretAgent_statusbarpanel.image = "chrome://SecretAgent/skin/icon16_green.gif";
           SecretAgent_statusbarpanel.setAttribute("tooltiptext", "Secret Agent is modifying HTTP requests" );
           SecretAgent_statusbarpanel.setAttribute("style", "color:#000066; font-weight:bold;");
     }
     else
     {
           SecretAgent_statusbarpanel.label = "Default";
           SecretAgent_statusbarpanel.image = "chrome://SecretAgent/skin/icon16_red.gif";
           SecretAgent_statusbarpanel.setAttribute("tooltiptext", "Secret Agent is not modifying HTTP requests"  );
           SecretAgent_statusbarpanel.setAttribute("style", "color:#cc6600; font-weight:bold;");
     }
   },

  // ------------------------------------------------------------------------------------------------
  // Set the text in the status bar panel
  setStatusBarPanelWhitelist: function(){		

     // Set the status bar message
     var SecretAgent_statusbarpanel = document.getElementById("SecretAgent_statusbarpanel");
     SecretAgent_statusbarpanel.image = "chrome://SecretAgent/skin/icon16.png";

     SecretAgent_statusbarpanel.label = "Whitelist";
     SecretAgent_statusbarpanel.image = "chrome://SecretAgent/skin/icon16_yellow.gif";
     SecretAgent_statusbarpanel.setAttribute("tooltiptext", "Secret Agent detected a whitelisted site" );
     SecretAgent_statusbarpanel.setAttribute("style", "color:#000066; font-weight:bold;");
   },

  // ------------------------------------------------------------------------------------------------
  // Toggle On/Off
  toggle: function(){		

	var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

     // Toggle Status and Set the status bar message
     if (secretAgentPreferences.getBoolPref("StealthMode"))
     {
         SecretAgent.off();
     }
     else
     {
         SecretAgent.on();
     }

   },

  
  // ------------------------------------------------------------------------------------------------
  // Initialise agents
  initialiseUserAgentList: function(){		
     var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

     SecretAgent['UserAgentList'] = secretAgentPreferences.getCharPref("UserAgentList").split("\n");
   },

  // ------------------------------------------------------------------------------------------------
  // Initialise accept headers
  initialiseAcceptList: function(){		
     var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

     SecretAgent['AcceptList'] = secretAgentPreferences.getCharPref("AcceptList").split("\n");
   },

  // ------------------------------------------------------------------------------------------------
  // Initialise OSCPU strings
  initialiseOSCPUList: function(){		
     var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

     SecretAgent['OSCPUList'] = secretAgentPreferences.getCharPref("OSCPUList").split("\n");
   },

  // ------------------------------------------------------------------------------------------------
  // Initialise whitelist
  initialiseWhitelist: function(){		
     var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

     SecretAgent['Whitelist'] = secretAgentPreferences.getCharPref("Whitelist").split("\n");
  },

  // ------------------------------------------------------------------------------------------------
  // Toggle whitelist entry
  toggleWhitelist: function(domain){		

     // Toggle Status and Set the status bar message
     if (SecretAgent.Whitelist.indexOf(domain) > -1)
     {
         SecretAgent.removefromWhitelist(domain);
     }
     else
     {
         SecretAgent.addtoWhitelist(domain);
     }

   },

   // ------------------------------------------------------------------------------------------------
  // Add host to whitelist
  addtoWhitelist: function( domain ) {
     var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

	 // Already in the list
     if (SecretAgent.Whitelist.indexOf(domain) > -1) return;

     SecretAgent['Whitelist'].unshift( domain );
	 
     var secretAgentPreferenceString = SecretAgent['Whitelist'].toString();
	 secretAgentPreferenceString = secretAgentPreferenceString.replace(/,/g,"\n");

     secretAgentPreferences.setCharPref("Whitelist", secretAgentPreferenceString);

     // Remove the override for this domain. This may leave some third party overrides in place, these are cleared on exit
     // Removing this value avoids generating a list in the preferences settings of every domain visited
     SecretAgent.clearDomainSpecificUserAgentOverrides( domain );

 },
  
  // ------------------------------------------------------------------------------------------------
  // Remove host from whitelist
  removefromWhitelist: function( domain ) {
     var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

	 // Already removed from the list
     if (SecretAgent.Whitelist.indexOf(domain) < 0) return;
	 
     SecretAgent['Whitelist'].splice( SecretAgent['Whitelist'].indexOf(domain), 1 );
	 
     var secretAgentPreferenceString = SecretAgent['Whitelist'].toString();
	 secretAgentPreferenceString = secretAgentPreferenceString.replace(/,/g,"\n");

     secretAgentPreferences.setCharPref("Whitelist", secretAgentPreferenceString);
  
  },
  
  // ------------------------------------------------------------------------------------------------
  // on
  on: function(){		
     var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

     // Start randomising the User Agent
     secretAgentPreferences.setBoolPref("StealthMode", true);

     SecretAgent.setStatusBarPanel();
   },

  // ------------------------------------------------------------------------------------------------
  // off
  off: function(){		

     var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);
     secretAgentPreferences = secretAgentPreferences.getBranch("extensions.SecretAgent.");

     secretAgentPreferences.setBoolPref("StealthMode", false);

     if (secretAgentPreferences.getBoolPref("RotateUserAgent"))
     {
         SecretAgent.clearGlobalUserAgentOverrides();
         SecretAgent.clearAllDomainSpecificUserAgentOverrides();
     }
     if (secretAgentPreferences.getBoolPref("RotateOSCPU"))
     {
         SecretAgent.clearGlobalOSCPUOverrides();
     }
			 	 
     // Refresh the Status Bar
     SecretAgent.setStatusBarPanel();
	 
  },

  
  //----------------------------------------------------------------------------------------------------
  // restore default user agent override preferences for all domains
  clearGlobalUserAgentOverrides: function() {
   
    // Remove general.useragent.override
    var generalUserAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentPreferences = generalUserAgentPreferences.getBranch("general.useragent.");

    try{ generalUserAgentPreferences.clearUserPref("override"); } catch(e) {
dump("SecretAgent: Exception;" + e.message + "\n");
	}

  },

  //----------------------------------------------------------------------------------------------------
  // restore default user agent override preferences for all domains
  clearGlobalOSCPUOverrides: function() {
   
    // Remove general.oscpu.override
    var generalOSCPUPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalOSCPUPreferences = generalOSCPUPreferences.getBranch("general.oscpu.");

    try{ generalOSCPUPreferences.clearUserPref("override"); } catch(e) {
dump("SecretAgent: Exception;" + e.message + "\n");
    }

  },

  //----------------------------------------------------------------------------------------------------
  // restore default preferences for all domain
  clearAllDomainSpecificUserAgentOverrides: function() {

    var generalUserAgentOverridePreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentOverridePreferences = generalUserAgentOverridePreferences.getBranch("general.useragent.override.");

    // Remove general.useragent.override.*
	generalUserAgentOverridePreferences.getChildList('', {}).forEach( SecretAgent.clearDomainSpecificUserAgentOverrides );
	
    try{ generalUserAgentOverridePreferences.deleteBranch(""); } catch(e) {
dump("SecretAgent: Exception;" + e.message + "\n");
	}

  },
	
  //----------------------------------------------------------------------------------------------------
  // restore default preferences for a given domain
  clearDomainSpecificUserAgentOverrides: function(domain) {
//alert("["+domain+"]");
    var generalUserAgentOverridePreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentOverridePreferences = generalUserAgentOverridePreferences.getBranch("general.useragent.override.");

	// Remove general.useragent.override.<domain>
	// This may leave some third party overrides in place, these are cleared on exit
    try{ generalUserAgentOverridePreferences.clearUserPref( domain ); } catch(e) {
dump("SecretAgent: Exception;" + e.message + "\n");
	}

  },
  
  //----------------------------------------------------------------------------------------------------
  onPageLoad: function(e) {
    // add event listener for page unload 
    e.originalTarget.defaultView.addEventListener("unload", function(event){ SecretAgent.onPageUnload(event); }, true);

  },

  //----------------------------------------------------------------------------------------------------
  onPageUnload: function(e) {

    var domain = e.originalTarget.domain; // document domain that triggered "onload" event

	// Remove the override for this domain. This may leave some third party overrides in place, so we clear all residual overrides afterward
	// Removing this value avoids generating a list in the preferences settings of every domain visited
    SecretAgent.clearDomainSpecificUserAgentOverrides(domain);
  
  }

}

