"use strict";
//SecretAgent
// 
//Licence Terms
// 
//1) SecretAgent is copyright Peter John
//
//You may;
//
//2) Download and install SecretAgent software for personal or commercial use
//
//3) You may use SecretAgent software on as many computers as you wish, without charge
//
//4) You may decompile the software, but only to verify the code will perform to specification
//
//You may not;
//
//5) Rebrand or bundle the code, or any part of the code, with any other software product
//
//6) Incorporate the code into a product or service involving Phorm or any other advertising system
//
//Specific Restrictions;
//
//7) SecretAgent software is not licenced for use by employees or sub-contractors working for Phorm, BT, Plusnet, TalkTalk, Virgin, Vodafone, BBC, News Corporation, News International, Logica, Experian, Verizon, Facebook, Schillings, Berenberg, Blackrock, Dartley Bank
//
//8) SecretAgent software is not licenced for use by employees or sub-contractors working for UK Central Government (including but not limited to the Information Commissioners Office, Home Office, Ministry of Justice, Dept for Business Innovation and Skills, Cabinet Office, Ministry of Defence, Foreign Office, Department for Education).
//
//9) SecretAgent software is not licenced for use by employees or sub-contractors working for UK Police forces
// 

function resetDefaults() {
   const nsIPrefService = Components.interfaces.nsIPrefService;

   var secretAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(nsIPrefService).getBranch("extensions.SecretAgent.");

   try{ secretAgentPreferences.clearUserPref("RotateUserAgent");            } catch(e) {}
   var checkRotateUserAgent = document.getElementById("checkRotateUserAgent");
   checkRotateUserAgent.checked=secretAgentPreferences.getBoolPref("RotateUserAgent");

   try{ secretAgentPreferences.clearUserPref("UserAgentList");              } catch(e) {}
   var txtUserAgentList = document.getElementById("txtOSCPUList");
   txtUserAgentList.checked=secretAgentPreferences.getCharPref("UserAgentList");

   try{ secretAgentPreferences.clearUserPref("RotateAccept");               } catch(e) {}
   var checkRotateAccept = document.getElementById("checkRotateAccept");
   checkRotateAccept.checked=secretAgentPreferences.getBoolPref("RotateAccept");
   
   try{ secretAgentPreferences.clearUserPref("AcceptList");                 } catch(e) {}
   var txtAcceptList = document.getElementById("txtOSCPUList");
   txtAcceptList.checked=secretAgentPreferences.getCharPref("AcceptList");

   try{ secretAgentPreferences.clearUserPref("RotateOSCPU");                } catch(e) {}
   var checkRotateOSCPU = document.getElementById("checkRotateOSCPU");
   checkRotateOSCPU.checked=secretAgentPreferences.getBoolPref("RotateOSCPU");

   try{ secretAgentPreferences.clearUserPref("OSCPUList");                  } catch(e) {}
   var txtOSCPUList = document.getElementById("txtOSCPUList");
   txtOSCPUList.checked=secretAgentPreferences.getCharPref("OSCPUList");
   
   try{ secretAgentPreferences.clearUserPref("Whitelist");                  } catch(e) {}
   var txtWhitelist = document.getElementById("txtWhitelist");
   txtWhitelist.checked=secretAgentPreferences.getCharPref("Whitelist");
   
   try{ secretAgentPreferences.clearUserPref("SpoofForwardedFor");          } catch(e) {}
   var checkSpoofForwardedFor = document.getElementById("checkSpoofForwardedFor");
   checkSpoofForwardedFor.checked=secretAgentPreferences.getBoolPref("SpoofForwardedFor");

   try{ secretAgentPreferences.clearUserPref("SpoofVia");                   } catch(e) {}
   var checkSpoofVia = document.getElementById("checkSpoofVia");
   checkSpoofVia.checked=secretAgentPreferences.getBoolPref("SpoofVia");

   try{ secretAgentPreferences.clearUserPref("SpoofETags");                 } catch(e) {}
   var checkSpoofETags = document.getElementById("checkSpoofETags");
   checkSpoofETags.checked=secretAgentPreferences.getBoolPref("SpoofETags");

   try{ secretAgentPreferences.clearUserPref("SpoofDatestamps");            } catch(e) {}
   var checkSpoofDatestamps = document.getElementById("checkSpoofDatestamps");
   checkSpoofDatestamps.checked=secretAgentPreferences.getBoolPref("SpoofDatestamps");

   try{ secretAgentPreferences.clearUserPref("StealthMode");                } catch(e) {}
   var checkStealthMode = document.getElementById("checkStealthMode");
   checkStealthMode.checked=secretAgentPreferences.getBoolPref("StealthMode");

   try{ secretAgentPreferences.clearUserPref("showStartupAlert");           } catch(e) {}
   var checkShowStartupAlert = document.getElementById("checkShowStartupAlert");
   checkShowStartupAlert.checked=secretAgentPreferences.getBoolPref("showStartupAlert");
   
}

function onCommandCheckRotateUserAgent() {

   var checkRotateUserAgent = document.getElementById("checkRotateUserAgent");

   if (!checkRotateUserAgent.checked)
   {
     // Restore default user agents
     clearGlobalUserAgentOverrides();
     clearAllDomainSpecificUserAgentOverrides();
   }

}
function onCommandCheckRotateOSCPU() {

   var checkRotateOSCPU = document.getElementById("checkRotateOSCPU");

   if (!checkRotateOSCPU.checked)
   {
     // Restore defaults OSCPU
     clearGlobalOSCPUOverrides();
   }
   
}

  //----------------------------------------------------------------------------------------------------
  // restore default preferences
function clearAllOverrides() {

	clearGlobalOSCPUOverrides();
	clearGlobalUserAgentOverrides();
    clearAllDomainSpecificUserAgentOverrides();
	
}
  
  //----------------------------------------------------------------------------------------------------
  // restore default user agent override preferences for all domains
function clearGlobalUserAgentOverrides() {
   
    // Remove general.useragent.override
    var generalUserAgentPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentPreferences = generalUserAgentPreferences.getBranch("general.useragent.");

    try{ generalUserAgentPreferences.clearUserPref("override"); } catch(e) {
dump("Exception;" + e.message + "\n");
	}

}

  //----------------------------------------------------------------------------------------------------
  // restore default user agent override preferences for all domains
function clearGlobalOSCPUOverrides() {
   
    // Remove general.oscpu.override
    var generalOSCPUPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalOSCPUPreferences = generalOSCPUPreferences.getBranch("general.oscpu.");

    try{ generalOSCPUPreferences.clearUserPref("override"); } catch(e) {
dump("Exception;" + e.message + "\n");
    }

}

  //----------------------------------------------------------------------------------------------------
  // restore default preferences for all domain
function clearAllDomainSpecificUserAgentOverrides() {

    var generalUserAgentOverridePreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentOverridePreferences = generalUserAgentOverridePreferences.getBranch("general.useragent.override.");

    // Remove general.useragent.override.*
	generalUserAgentOverridePreferences.getChildList('', {}).forEach( clearDomainSpecificUserAgentOverrides );
	
    try{ generalUserAgentOverridePreferences.deleteBranch(""); } catch(e) {
dump("Exception;" + e.message + "\n");
	}

}
	
  //----------------------------------------------------------------------------------------------------
  // restore default preferences for a given domain
function clearDomainSpecificUserAgentOverrides(domain) {
//alert("["+domain+"]");
    var generalUserAgentOverridePreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    generalUserAgentOverridePreferences = generalUserAgentOverridePreferences.getBranch("general.useragent.override.");

	// Remove general.useragent.override.<domain>
	// This may leave some third party overrides in place, these are cleared on exit
    try{ generalUserAgentOverridePreferences.clearUserPref( domain ); } catch(e) {
dump("Exception;" + e.message + "\n");
	}

}
  
